<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                xmlns:misc="http://java.sun.com/jsf/composite/misc"
                xmlns:actualizacion="http://java.sun.com/jsf/composite/actualizacion"
                template="/templates/generalCU.xhtml">

    <!-- CASO DE USO CU-NP-FA-103 -->

    <ui:define name="title">
        .::Sistema Nacional Catastral::. .:: Registrar convenio ::.
    </ui:define>

    <ui:define name="content">

        <p:ajaxStatus onstart="statusDialog.show();"
                      onsuccess="statusDialog.hide();" />

        <actualizacion:actualizacionResumenCC id="actualizacionResumen"
                                              actualizacionParam="#{gestionarProyectoDeNomenclaturaVial.actualizacionSeleccionada}"
                                              muestraNumeroConvenioParam="false" />

        <p:messages id="msgRegistrarConvenio" showDetail="false"
                    globalOnly="false" />

        <h:form id="registrarConvenioForm" enctype="multipart/form-data">

            <p:panel header="Gestionar propuesta de convenio"
                     id="gestionarPropuestaCvnio">

                <p:tabView cache="true" dynamic="true" id="editarConvenio">

                    <p:messages id="msgConvenio" showDetail="false" globalOnly="false" />

                    <p:tab title="Registrar convenio">
                        <h:panelGrid id="datosConvenioActualizacion">
                            <h:panelGrid columns="9" cellspacing="3" cellpadding="3">

                                <h:panelGrid columns="2">
                                    <h:outputLabel value="Tipo de proyecto:"
                                                   styleClass="outputLabelStyle" />
                                    <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                                </h:panelGrid>
                                <h:selectOneMenu id="tipoProyectoCB" label="Tipo de proyecto"
                                                 value="#{registrarConvenio.convenioSeleccionado.tipoProyecto}"
                                                 title="Tipo de proyecto" required="true"
                                                 style="width:150px;height:30x;">
                                    <f:selectItems
                                        value="#{general.actualizacionConvenioTipoProyectoV}" />
                                </h:selectOneMenu>
                                <p:message for="tipoProyectoCB" display="icon"
                                           id="tipoProyectoCBMsg" />


                                <h:panelGrid columns="2">
                                    <h:outputLabel value="Zona:" styleClass="outputLabelStyle" />
                                    <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                                </h:panelGrid>
                                <h:selectOneMenu id="zonaCB" label="Zona" title="Zona"
                                                 required="true"
                                                 value="#{registrarConvenio.convenioSeleccionado.zona}"
                                                 style="width:150px;height:30x;">
                                    <f:selectItems value="#{general.actualizacionZonaV}" />
                                </h:selectOneMenu>
                                <p:message for="zonaCB" display="icon" id="zonaCBMsg" />


                                <h:panelGrid columns="2">
                                    <h:outputLabel value="No. de convenio IGAC:"
                                                   styleClass="outputLabelStyle" />
                                    <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                                </h:panelGrid>
                                <h:inputText id="convenioIGACCB" title="Número de convenio"
                                             value="#{registrarConvenio.convenioSeleccionado.numero}"
                                             maxlength="19" size="27" label="Número de convenio"
                                             required="true" />
                                <p:message for="convenioIGACCB" display="icon"
                                           id="convenioIGACCBMsg" />


                                <h:panelGrid columns="2">
                                    <h:outputLabel value="Clase de convenio:"
                                                   styleClass="outputLabelStyle" />
                                    <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                                </h:panelGrid>
                                <h:selectOneMenu id="claseConvenioCB" label="Clase de convenio"
                                                 title="Clase de convenio"
                                                 value="#{registrarConvenio.convenioSeleccionado.clase}"
                                                 style="width:145px;height:30x;" required="true">
                                    <f:selectItems value="#{general.actualizacionConvenioClaseV}" />
                                </h:selectOneMenu>
                                <p:message for="claseConvenioCB" display="icon"
                                           id="claseConvenioCBMsg" />

                                <h:panelGrid columns="2">
                                    <h:outputLabel value="Valor: " styleClass="outputLabelStyle" />
                                    <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                                </h:panelGrid>
                                <h:inputText id="valor" title="Valor" maxlength="18"
                                             value="#{registrarConvenio.convenioSeleccionado.valor}"
                                             size="23" label="Valor" required="true">
                                    <f:convertNumber type="number" maxIntegerDigits="17"
                                                     maxFractionDigits="2" />
                                </h:inputText>
                                <p:message for="valor" display="icon" id="valorMsg" />


                                <h:panelGrid columns="2">
                                    <h:outputLabel value="Objeto: " styleClass="outputLabelStyle" />
                                    <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                                </h:panelGrid>
                                <h:inputTextarea id="objeto" title="Objeto"
                                                 value="#{registrarConvenio.convenioSeleccionado.objeto}"
                                                 cols="36" rows="2" label="Objeto"
                                                 required="true" onkeydown="controlarNroChars(this, 2000, true)"
                                                 onkeyup="controlarNroChars(this, 2000, true)" />
                                <p:message for="objeto" display="icon" id="objetoMsg" />



                                <h:panelGrid columns="2">
                                    <h:outputLabel value="Plazo de ejecución hasta el: "
                                                   styleClass="outputLabelStyle" />
                                    <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                                </h:panelGrid>
                                <p:calendar title="Plazo de ejecución (dd/MM/YYYY)"
                                            value="#{registrarConvenio.convenioSeleccionado.plazoEjecucion}"
                                            id="plazoEjecucion" showOn="button" navigator="true"
                                            required="true" label="Plazo de ejecución"
                                            size="15" pattern="#{general.formatoFechaComponenteCalendar}" />
                                <p:message for="plazoEjecucion" display="icon"
                                           id="plazoEjecucionMsg" />

                                <h:panelGrid columns="2">
                                    <h:outputLabel value="Año de actualización: "
                                                   for="claseConvenioCB" styleClass="outputLabelStyle" />
                                    <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                                </h:panelGrid>
                                <h:selectOneMenu id="anioActualizacion"
                                                 title="Año de actualización" label="Año de actualización"
                                                 required="true" value="#{registrarConvenio.actualizacion.anio}"
                                                 style="width:145px;height:30x;">
                                    <f:selectItems value="#{registrarConvenio.anioActualizacion}" />
                                </h:selectOneMenu>
                                <p:message for="anioActualizacion" display="icon"
                                           id="anioActualizacionMsg" />

                            </h:panelGrid>

                            <p:outputPanel layout="block" style="text-align:right"
                                           id="guardarConvenioPanel">
                                <p:commandButton label="Guardar convenio"
                                                 update=":registrarConvenioForm:editarConvenio:datosConvenioActualizacion, :msgRegistrarConvenio"
                                                 value="Guardar convenio" process="datosConvenioActualizacion"
                                                 action="#{registrarConvenio.guardarConvenio}"
                                                 id="guardarConvenioBtn" icon="ui-icon-disk"
                                                 title="Guardar convenio">
                                </p:commandButton>
                            </p:outputPanel>
                            <p:spacer height="10" />

                        </h:panelGrid>

                        <p:fieldset>
                            <legend> <h:outputLabel value="Entidades contratantes"
                                                    styleClass="legendTitle" /> </legend>

                            <h:panelGrid columns="1" cellspacing="2" width="100%"
                                         id="panelTablaEntidadesContratantes">

                                <p:dataTable id="tablaEntidadesContratantes"
                                             var="convenioEntidad" editable="true"
                                             value="#{registrarConvenio.entidadesContratantes}"
                                             selectionMode="single"
                                             selection="#{registrarConvenio.entidadSeleccionada}"
                                             rowKey="#{convenioEntidad.id}"
                                             emptyMessage="No existen entidades contratantes a mostrar"
                                             paginator="true" rows="5"
                                             paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                             paginatorPosition="bottom" rowsPerPageTemplate="5,10,15">

                                    <p:column headerText="Opciones">
                                        <p:commandButton update=":entidadContratanteForm"
                                                         oncomplete="entidadContratanteWV.show()" process="@this"
                                                         id="modificarEntidadBtn" icon="ui-icon ui-icon-pencil"
                                                         title="Editar entidad" label="Editar entidad">
                                            <f:setPropertyActionListener value="#{convenioEntidad}"
                                                                         target="#{registrarConvenio.entidadSeleccionada}" />
                                            <f:setPropertyActionListener value="true"
                                                                         target="#{registrarConvenio.editModeBool}" />
                                        </p:commandButton>

                                        <p:commandButton id="eliminarEntidadBtn" process="@this"
                                                         update="tablaEntidadesContratantes"
                                                         oncomplete="handleCompleteSIC(xhr, status,args, confirmEliminarEntidadWV, true);"
                                                         title="Eliminar entidad" label="Eliminar entidad"
                                                         icon="ui-icon-trash">
                                            <f:setPropertyActionListener value="#{convenioEntidad}"
                                                                         target="#{registrarConvenio.entidadSeleccionada}" />
                                        </p:commandButton>
                                    </p:column>

                                    <p:column headerText="Entidad">
                                        <h:outputText value="#{convenioEntidad.nombre}"
                                                      styleClass="outputTextStyle" />
                                    </p:column>

                                    <p:column headerText="NIT">
                                        <h:outputText value="#{convenioEntidad.nit}"
                                                      styleClass="outputTextStyle" />
                                    </p:column>

                                    <p:column headerText="Porcentaje de participación">
                                        <h:outputText
                                            value="#{convenioEntidad.porcentajeParticipacion}"
                                            styleClass="outputTextStyle">
                                            <f:convertNumber type="number" maxIntegerDigits="3"
                                                             maxFractionDigits="3" />
                                        </h:outputText>
                                    </p:column>

                                    <p:column headerText="Monto">
                                        <h:outputText value="$" />
                                        <h:outputText value="#{convenioEntidad.monto}">
                                            <f:convertNumber type="number" maxFractionDigits="0" />
                                        </h:outputText>
                                    </p:column>

                                    <p:column headerText="Convenio No.">
                                        <h:outputText value="#{convenioEntidad.numeroConvenio}"
                                                      styleClass="outputTextStyle" />
                                    </p:column>

                                </p:dataTable>

                                <p:outputPanel layout="block" style="text-align:right"
                                               id="editarEntidades">

                                    <p:commandButton
                                        update=":registrarConvenioForm, :msgRegistrarConvenio, :entidadContratanteForm"
                                        value="Adicionar entidad"
                                        oncomplete="entidadContratanteWV.show()" immediate="true"
                                        id="adicionarBtn" title="Adicionar entidad" label="Adicionar entidad"
                                        action="#{registrarConvenio.reiniciarVariables}"
                                        icon="ui-icon-plus">
                                        <f:setPropertyActionListener value="false"
                                                                     target="#{registrarConvenio.editModeBool}" />
                                    </p:commandButton>

                                </p:outputPanel>
                            </h:panelGrid>
                        </p:fieldset>
                        <h:panelGrid>
                            <p:spacer height="10" />

                            <p:fileUpload id="cargarArchivoBtn" label="Cargar archivo"
                                          fileUploadListener="#{registrarConvenio.cargarArchivo}"
                                          dragDropSupport="true"
                                          invalidSizeMessage="El archivo seleccionado supera el tamaño permitido"
                                          widgetVar="uploader" mode="advanced" auto="true"
                                          sizeLimit="#{general.maximoTamanoAdjuntos}"
                                          allowTypes="/(\.|\/)(pdf|dwg|tif|png|jpg)$/" />
                            <p:spacer height="5" />

                            <p:commandButton
                                update=":registrarConvenioForm, :msgRegistrarConvenio"
                                value="Finalizar" process="@this"
                                style="width:160px;height:60x;" ajax="false"
                                disabled="#{registrarConvenio.convenioRegistrado}"
                                action="#{registrarConvenio.finalizar}" id="finalizarBtn"
                                icon="ui-icon-circle-check" title="Finalizar" label="Finalizar">
                            </p:commandButton>
                        </h:panelGrid>
                    </p:tab>

                    <p:tab title="Revisar convenio"
                           rendered="#{registrarConvenio.convenioRegistrado}">
                        <h:panelGrid>
                            <ui:include src="datosRegistrarConvenioMuestra.xhtml" />
                        </h:panelGrid>
                        <p:outputPanel layout="block" style="text-align:center">

                            <p:commandButton value="Aprobar" id="btnAprobar" ajax="false"
                                             action="#{registrarConvenio.aprobarRegistroDeConvenio}"
                                             update=":viewReport:vistaMemoForm" icon="ui-icon-script"
                                             title="Aprovar" label="Aprovar"
                                             oncomplete="visorReporteWV.show()" />

                            <p:spacer width="30" height="30" />

                            <p:commandButton value="Ordenar revisión"
                                             icon="ui-icon-circle-check" id="btnOrdenarRevision"
                                             update=":ordenarRevisionConvenioForm"
                                             title="Ordenar revisión" label="Ordenar revisión"
                                             oncomplete="ordenarRevisionConvenioWV.show()" />
                        </p:outputPanel>
                    </p:tab>
                </p:tabView>

                <p:outputPanel layout="block" style="text-align:right">
                    <p:commandButton value="Cerrar" icon="ui-icon-close"
                                     title="Cerrar" label="Cerrar"
                                     action="#{registrarConvenio.cerrar}" ajax="false" immediate="true" />
                    <p:spacer width="30" height="30" />
                </p:outputPanel>

            </p:panel>
        </h:form>

        <misc:confirmationWithConfirmDialogCC
            confirmMessage="¿Está seguro de eliminar la entidad?"
            confirmUpdate=":registrarConvenioForm"
            confirmAction="#{registrarConvenio.eliminarEntidad}"
            confirmDialogWV="confirmEliminarEntidadWV" />

        <p:dialog header="Entidad contratante"
                  widgetVar="entidadContratanteWV" modal="true" appendToBody="true"
                  resizable="true" position="center">

            <h:form id="entidadContratanteForm">
                <p:fieldset>

                    <p:messages id="msgEntidadContratante" showDetail="false"
                                globalOnly="false" />

                    <h:panelGrid columns="1" cellspacing="5" width="100%">

                        <h:panelGrid columns="4" width="100%" cellpadding="5"
                                     cellspacing="5">

                            <h:outputLabel value="Entidad: " styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                            <h:inputText
                                value="#{registrarConvenio.entidadSeleccionada.nombre}"
                                id="entidad" required="true" maxlength="99"
                                label="Nombre de la entidad" style="width:150px;height:14px;" />
                            <p:message for="entidad" display="icon" />

                            <h:outputLabel value="NIT: " styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                            <h:inputText value="#{registrarConvenio.entidadSeleccionada.nit}"
                                         id="nit" required="true" maxlength="19"
                                         label="NIT de la entidad" style="width:150px;height:14px;" />
                            <p:message for="nit" display="icon" />

                            <h:outputLabel value="Porcentaje de participación: "
                                           styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                            <h:inputText
                                value="#{registrarConvenio.entidadSeleccionada.porcentajeParticipacion}"
                                id="porcentajeParticipacion" required="true" maxlength="7"
                                label="Porcentaje de participación"
                                style="width:150px;height:14px;">
                                <f:convertNumber type="number" />
                            </h:inputText>
                            <p:message for="porcentajeParticipacion" display="icon" />

                            <h:outputLabel value="Monto: " styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                            <h:inputText
                                value="#{registrarConvenio.entidadSeleccionada.monto}"
                                id="monto" required="true" maxlength="20" label="Monto"
                                style="width:150px;height:14px;">
                                <f:convertNumber type="number" />
                            </h:inputText>
                            <p:message for="monto" display="icon" />

                            <h:outputLabel value="Número del convenio "
                                           styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                            <h:inputText
                                value="#{registrarConvenio.entidadSeleccionada.numeroConvenio}"
                                id="numeroConvenio" required="true" maxlength="19"
                                label="Número del convenio" style="width:150px;height:14px;">
                            </h:inputText>
                            <p:message for="numeroConvenio" display="icon" />

                        </h:panelGrid>

                        <p:outputPanel layout="block" style="text-align:right">
                            <p:commandButton value="Aceptar" id="guardarEntidadBtn"
                                             process="@form" label="Guardar entidad" title="Guardar entidad"
                                             update=":registrarConvenioForm, entidadContratanteForm"
                                             action="#{registrarConvenio.guardarEntidad}"
                                             icon="ui-icon-check"
                                             oncomplete="handleCompleteSIC(xhr, status, args, entidadContratanteWV, false)">
                            </p:commandButton>
                            <p:spacer width="20" />
                        </p:outputPanel>
                    </h:panelGrid>
                </p:fieldset>
            </h:form>
        </p:dialog>

        <p:dialog header="Ordenar revisión a información sobre convenio"
                  widgetVar="ordenarRevisionConvenioWV" hideEffect="explode"
                  width="900" height="550" appendToBody="true">
            <ui:include src="ordenarRevisionConvenio.xhtml"
                        id="ordenarRevisionConvenioModal" />
        </p:dialog>

        <misc:visualizadorMemorandosCC
            id="viewReport"
            thisWVName="visorReporteWV"
            urlDocumento="#{registrarConvenio.reporteAprobacionDeConvenio.urlWebReporte}"
            fileContent="#{registrarConvenio.reporteAprobacionDeConvenio.streamedContentReporte}"
            documentoGenerado="#{registrarConvenio.reporteAprobacionDeConvenio ne null}"
            radicarButtonAction="#{registrarConvenio.aprobarRegistroDeConvenio}"
            cancelButtonEnabled="false"/>

    </ui:define>
</ui:composition>

